/*
 * BombHandler.cpp
 *
 *  Created on: Jan 5, 2014
 *      Author: brian
 */

#include "BombHandler.h"
#include "Game.h"

BombHandler* BombHandler::s_pInstance = new BombHandler();

BombHandler::BombHandler() {

}

//  (*p_it)->getPosition().getY() > TheGame::Instance()->getGameHeight()

void BombHandler::playStateUpdate() {
	if (! m_bombs.empty() ) {
		Bomb* b_begin = m_bombs.front();
		//cout << "y is " << b_begin->getPosition().getY() << endl;

		if (b_begin->getPosition().getY() > TheGame::Instance()->getGameHeight() - 40)
		{
			//cout << "bomb went off screen" << endl;
			TheGame::Instance()->bombHit();

		}
	}

}

void BombHandler::startExploding() {
	Bomb* b_begin = m_bombs.front();
	if (b_begin != NULL) {
		b_begin->setExploding();
	}
}

void BombHandler::explodeStateUpdate() {
	if (m_bombs.empty()) {
		//cout << "Bombs are empty" << endl;
		TheGame::Instance()->setBombsEmpty();
		// we are done now
		return;
	}
	// Make sure the first bomb is exploding
	Bomb* b_begin = m_bombs.front();
	//b_begin->setExploding();


}


void BombHandler::addBomb(Bomb* &aBomb ) {
	aBomb->setFall(1);
	m_bombs.push_back(aBomb);
}



void BombHandler::updateBombs()
{
	switch (TheGame::Instance()->getState()) {
	case PAUSE:
		break;
	case PLAY:
		playStateUpdate();
		break;
	case EXPLODE:
		explodeStateUpdate();
		break;
	default:
		;
	}

	// check for off the top or left or right screen bombs and delete them
	// delete caught bombs

    for (std::vector<Bomb*>::iterator p_it = m_bombs.begin(); p_it != m_bombs.end();)
    {

        if((*p_it)->getPosition().getX() < 0 || (*p_it)->getPosition().getX() > TheGame::Instance()->getGameWidth()
           || (*p_it)->getPosition().getY() < 0
           || (*p_it)->isCaught() || (*p_it)->isExploded())
        {
        	//cout << "delete a bomb" << endl;
            if ((*p_it)->isCaught()) {
            	TheGame::Instance()->incCaught();
            }
            delete * p_it;
            p_it = m_bombs.erase(p_it);
            if (TheGame::Instance()->getState()  == EXPLODE)
            	(*p_it)->setExploding();
        }
        else {

            (*p_it)->update();
            ++p_it;
        }

    }



}



void BombHandler::drawBombs(SDL_Renderer* pRenderer) {
    for (int p = 0; p < m_bombs.size(); p++)
    {
        m_bombs[p]->draw(pRenderer);
    }
}
