#include "Bomber.h"
#include "Bomb.h"
#include "InputHandler.h"
#include "BombHandler.h"
#include "TextureManager.h"
#include "Game.h"

#include <vector>

Bomber::Bomber() :
		m_direction(1),has_bomb(false), bomber_xm_time(2), bomber_xm(2), m_frameCount(0) {
	//m_direction = 1;
	//cout << "Bomber Constructor " << endl;
	moveLastTime = SDL_GetTicks()/10;

	// default value
	bombDelayTime = 300;

	m_x = rand() % 400 + 30;
}

Bomber::~Bomber() {

	//cout << "Bomber Destructor " << endl;

}

void Bomber::reset() {
	m_x = rand() % 400 + 30;
	bomber_xm = 2;
	bomber_xm_time = 2;
}

void Bomber::playUpdate() {

	if (m_bombs_left > 0)
		m_x += bomber_xm * m_direction;

	// check if bomber went off edge
	// and put him back at the border going
	// opposite direction
	if (m_x > 588) {
		m_x = 588;
		m_direction *= -1;
	}
	if (m_x < 30) {
		m_x = 30;
		m_direction *= -1;
	}

	moveCurrentTime = SDL_GetTicks() / 10;

	if ((moveCurrentTime - moveLastTime) >= bomber_xm_time) {
		bomber_xm_time = (rand() % (m_level * 50)) + 128 / m_level;
		int tmpx = rand() % 8 + 2;
		bomber_xm = tmpx / 2 * (tmpx % 2 == 1 ? 1 : -1) * (m_level + 1) / 2;
		moveLastTime = SDL_GetTicks() / 10;

	}

	bombCurrentTime = SDL_GetTicks();
	if (m_bombs_left > 0) {
		if (bombCurrentTime - bombLastTime > bombDelayTime) {
			m_bomb = new Bomb();
			//has_bomb = true;
			m_bomb->load(m_x, m_y + 40, 32, 32, "bomb");
			TheBombHandler::Instance()->addBomb(m_bomb);
			m_bombs_left--;
			bombLastTime = SDL_GetTicks();

		}
	}


	if (has_bomb == true) {
		m_bomb->setX(m_x);
		m_bomb->update();
	}
	BombHandler::Instance()->updateBombs();
}

void Bomber::explodeUpdate() {
	BombHandler::Instance()->updateBombs();
}

void Bomber::update() {
	// current frame in the sprite
	m_currentFrame = 0;
	// nth frame we are drawing for the game
	m_frameCount++;

//	if (TheGame::Instance()->getState() == PLAY) {
//		playUpdate();
//	} else if (TheGame::Instance()->getState() == EXPLODE) {
//		explodeUpdate();
//	}

	switch (TheGame::Instance()->getState() ) {
	case PLAY:
		playUpdate();
		break;
	case EXPLODE:
		explodeUpdate();
		break;
	case PAUSE:
		//cout << "Current state is pause" << endl;
		break;
	default:
		break;
	}


}

void Bomber::load(int x, int y, int width, int height, std::string textureID) {
	GameObject::load(x, y, width, height, textureID);
	//load(x, y, width, height, textureID);
}

void Bomber::draw(SDL_Renderer* pRenderer) {
	//TextureManager::Instance()->scaleFrame(m_textureID, m_x, m_y, m_width, m_height, m_destWidth, m_destHeight, m_currentRow, m_currentFrame, pRenderer);
	 //TextureManager::Instance()->drawFrame(m_textureID, m_x, m_y, m_width, m_height, m_currentRow, m_currentFrame, pRenderer);
	GameObject::draw(pRenderer);
	if (has_bomb == true)
		m_bomb->draw(pRenderer);
	BombHandler::Instance()->drawBombs(pRenderer);
}

void Bomber::clean() {
}

void Bomber::setLevel(int level) {
	  m_level = level;
	  // y = m * x + b
	  // m = -400 / 7
	  // b = 557
	  bombDelayTime = (uint) (level * (-400) / 7 + 557);
	  cout << "bombDelayTime " << bombDelayTime << endl;
}

